use db::folder::FolderWithoutParentId;

use crate::prelude::*;

pub async fn get_top_level(
    State(pool): State<Pool>,
    claims: Claims,
) -> GeneralResult<Json<Vec<FolderWithoutParentId>>> {
    db::permissions::get_top_level_permitted_folders(claims.user_id, &pool)
        .await
        .handle_internal("Error reading from the database")
        .map(Json)
}
